property WhereTo, RolloverCursor, Rollovermember, StandardMember, savedCursor, spriteNum, soundmember, soundChannel

on getPropertyDescriptionList me
  description = [:]
  Soundmememberlist = searchSoundMember(me)
  if the currentSpriteNum = 0 then
    exit
  end if
  theMember = sprite(the currentSpriteNum).member
  theMemberNumber = theMember.number
  addProp(description, #RolloverCursor, [#comment: "Set the RollOver Cursor To(On Rollver) :", #format: #cursor, #default: 280])
  addProp(description, #Rollovermember, [#comment: "Set RollOver Member To :", #format: #graphic, #default: member(theMemberNumber + 1)])
  if Soundmememberlist.count > 0 then
    addProp(description, #soundmember, [#comment: "Play Sound on rollover :", #format: #string, #range: Soundmememberlist, #default: Soundmememberlist[1]])
    addProp(description, #soundChannel, [#comment: "Choose SoundChannel :", #format: #integer, #range: [#min: 1, #max: 8], #default: 1])
  end if
  return description
end

on getBehaviorDescription me
  return "Change Cursor,Memer and Play sound On Rollover " & RETURN & RETURN & "This Behavior Changes the Member & Cursor of the sprite to the Specified member and Cursor and Plays the Sound specified." & RETURN & RETURN & "PARAMETERS:" & RETURN & "* RollOver Cursor" & RETURN & "* RollOver Member" & RETURN & "* Sound Member" & RETURN & "* Sound Channel"
end

on isOKToAttach me, aSpriteType, aSpriteNum
  case aSpriteType of
    #graphic:
      return 1
    #script:
      return 0
  end case
end

on beginSprite
  StandardMember = sprite(spriteNum).member
  savedCursor = sprite(spriteNum).cursor
end

on mouseEnter me
  sprite(spriteNum).member = Rollovermember
  sprite(spriteNum).cursor = RolloverCursor
  updateStage()
  if soundChannel >= 1 then
    if member(soundmember).type = #sound then
      puppetSound(soundChannel, soundmember)
    end if
    if member(soundmember).type = #swa then
      member(soundmember).play()
    end if
  end if
end

on mouseLeave me
  sprite(spriteNum).member = StandardMember
  sprite(spriteNum).cursor = savedCursor
  updateStage()
  if soundChannel >= 1 then
    if member(soundmember).type = #sound then
      puppetSound(soundChannel, 0)
    end if
    if member(soundmember).type = #swa then
      member(soundmember).stop()
    end if
  end if
end

on searchSoundMember me
  Soundmememberlist = []
  maxCastLib = the number of castLibs
  repeat with theCastLib = 1 to maxCastLib
    maxMember = the number of castMembers of castLib theCastLib
    repeat with memberNumber = 1 to maxMember
      theMember = member(memberNumber, theCastLib)
      if (theMember.type = #sound) or (theMember.type = #swa) then
        if theMember.name = EMPTY then
          Soundmememberlist.append(theMember)
          next repeat
        end if
        Soundmememberlist.append(theMember.name)
      end if
    end repeat
  end repeat
  return Soundmememberlist
end
